Subject: Re: git-archive and tar options

From: Neal Kreitzinger <[email-masked]>
Date: Mon, 18 Jul 2011 13:13:53 -0500

On 7/14/2011 12:27 PM, Jeff King wrote:
> On Thu, Jul 14, 2011 at 07:16:24PM +0200, René Scharfe wrote:
>
>>>> git archive --format=tar -o my.tar --transform
>>>> 's,^Web/Templates/,myPath/myWeb/Templates/,' HEAD
>>>> WebPortal/Templates/ error: unknown option `transform'
>>>
>>> Yeah, that won't work, because there is no such option. We do
>>> have "--prefix", but I suspect that's not flexible enough for
>>> what you want.
>>
>> If you only need a single subdirectory with a custom prefix you
>> could do something like this (variables only used to keep the lines
>> short):
>>
>> $ subdir=WebPortal/Templates $ prefix=myPath/myWeb/Templates/ $ (cd
>> "$subdir"&&  git archive --prefix="$prefix" HEAD)>my.tar
>>
>> The output file can be specified with -o as well, of course, but
>> you'd either need to use an absolute path or add "../" for each
>> directory level you descend into (-o ../../my.tar in this case).
>
> Couldn't you also do:
>
> git archive --prefix=$prefix HEAD:$subdir>my.tar
>
> ? I guess that loses the pax header with the commit sha1 in it,
> though, because you are feeding a straight tree instead of a commit.
>
> We didn't when git-archive was written, but these days we have
> get_sha1_with_context to remember incidental things about an object
> we look up. It should perhaps remember the commit (if any) we used to
> reach a treeish, and then the above command line could still insert
> the pax header.
>
HEAD:$subdir worked on my bare repo.  I ran it for each transformant 
pathspec and then combined the archives with tar --catenate:

# git archive --format=tar --prefix=myWeb/myRoot/myAPP/Templates/
HEAD:WebPortal/Templates/ >myAPP.myTag.tar
# git archive --format=tar --prefix=opt/mySTUFF/v01/SCRIPTS/
HEAD:SCRIPTS/ >SCRIPTS.tar
# tar --file=myAPP.myTag.tar -A SCRIPTS.tar

However, the permissions also need to change to 777 and tar --mode would 
not effect this in combination with --catenation or -x.  Is there a way 
I can change the permissions without having to untar->chmod->retar, and 
without having to use a non-bare repo as an intermediary?

v/r,
neal